com.io7m.r2.core.shaders.provided

## Class R2RefractionMaskedDeltaShaderBillboarded

- java.lang.Object
- - com.io7m.r2.core.shaders.provided.R2AbstractShader<R2RefractionMaskedDeltaParameters>
  - - com.io7m.r2.core.shaders.provided.R2RefractionMaskedDeltaShaderBillboarded

- All Implemented Interfaces:
    com.io7m.jcanephora.core.JCGLResourceUsableType, R2DeletableType, R2ShaderTranslucentInstanceBillboardedType<R2RefractionMaskedDeltaParameters>, R2ShaderTranslucentInstanceBillboardedUsableType<R2RefractionMaskedDeltaParameters>, R2ShaderTranslucentType<R2RefractionMaskedDeltaParameters>, R2ShaderTranslucentUsableType<R2RefractionMaskedDeltaParameters>, R2ShaderType<R2RefractionMaskedDeltaParameters>, R2ShaderUsableType<R2RefractionMaskedDeltaParameters>

      public final class R2RefractionMaskedDeltaShaderBillboarded
      extends R2AbstractShader<R2RefractionMaskedDeltaParameters>
      implements R2ShaderTranslucentInstanceBillboardedType<R2RefractionMaskedDeltaParameters>

  Shader for refracting billboarded instances.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static R2ShaderTranslucentInstanceBillboardedType<R2RefractionMaskedDeltaParameters>` | `newShader(com.io7m.jcanephora.core.api.JCGLShadersType in_shaders, R2ShaderPreprocessingEnvironmentReadableType in_shader_env, R2IDPoolType in_pool)` Construct a new shader.
    `void` | `onReceiveMaterialValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g, R2ShaderParametersMaterialType<R2RefractionMaskedDeltaParameters> mat_parameters)` Set material values.
    `void` | `onReceiveViewValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g, R2ShaderParametersViewType view_parameters)` Set shader values that are derived from the current view.
    `void` | `onValidate()` Validate the shader prior to executing a draw call.
    `Class<R2RefractionMaskedDeltaParameters>` | `shaderParametersType()`
    `Optional<com.io7m.jcanephora.renderstate.JCGLBlendState>` | `suggestedBlendState()` A specification of the blending state with which this shader is intended to be used.

    - ### Methods inherited from class com.io7m.r2.core.shaders.provided.R2AbstractShader

      `delete, isDeleted, onActivate, onDeactivate, shaderID, shaderProgram`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.r2.core.R2DeletableType

      `delete`

    - ### Methods inherited from interface com.io7m.r2.core.shaders.types.R2ShaderUsableType

      `onActivate, onDeactivate, shaderID, shaderProgram`

    - ### Methods inherited from interface com.io7m.jcanephora.core.JCGLResourceUsableType

      `isDeleted`

- - ### Method Detail

    - #### newShader

          public static R2ShaderTranslucentInstanceBillboardedType<R2RefractionMaskedDeltaParameters> newShader(com.io7m.jcanephora.core.api.JCGLShadersType in_shaders,
                                                                                                                R2ShaderPreprocessingEnvironmentReadableType in_shader_env,
                                                                                                                R2IDPoolType in_pool)

      Construct a new shader.
      Parameters:
        `in_shaders` - A shader interface
        `in_shader_env` - A shader preprocessing environment
        `in_pool` - The ID pool
      Returns:
        A new shader

    - #### shaderParametersType

          public Class<R2RefractionMaskedDeltaParameters> shaderParametersType()

      Specified by:
        `shaderParametersType` in interface `R2ShaderUsableType<R2RefractionMaskedDeltaParameters>`
      Returns:
        The shader parameter type

    - #### onReceiveViewValues

          public void onReceiveViewValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g,
                                          R2ShaderParametersViewType view_parameters)

      Description copied from interface: `R2ShaderTranslucentInstanceBillboardedUsableType`

      Set shader values that are derived from the current view.

      This method will be called exactly once between calls to `R2ShaderUsableType.onActivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type)` and `R2ShaderUsableType.onValidate()`.

      Specified by:
        `onReceiveViewValues` in interface `R2ShaderTranslucentInstanceBillboardedUsableType<R2RefractionMaskedDeltaParameters>`
      Parameters:
        `g` - An OpenGL interface
        `view_parameters` - The view parameters

    - #### onValidate

          public void onValidate()
                          throws R2ExceptionShaderValidationFailed

      Description copied from interface: `R2ShaderUsableType`
      Validate the shader prior to executing a draw call. This method exists so that shader implementations can check that the caller has called all required methods before drawing.
      Specified by:
        `onValidate` in interface `R2ShaderUsableType<R2RefractionMaskedDeltaParameters>`
      Throws:
        `R2ExceptionShaderValidationFailed` - If validation fails

    - #### onReceiveMaterialValues

          public void onReceiveMaterialValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g,
                                              R2ShaderParametersMaterialType<R2RefractionMaskedDeltaParameters> mat_parameters)

      Description copied from interface: `R2ShaderTranslucentInstanceBillboardedUsableType`

      Set material values.

      This method will be called once for each group of instances that use the material `M`.

      This method will be called after a call to `R2ShaderUsableType.onActivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type)` and before a call to `R2ShaderUsableType.onValidate()`.

      Specified by:
        `onReceiveMaterialValues` in interface `R2ShaderTranslucentInstanceBillboardedUsableType<R2RefractionMaskedDeltaParameters>`
      Parameters:
        `g` - A texture interface
        `mat_parameters` - The material parameters

    - #### suggestedBlendState

          public Optional<com.io7m.jcanephora.renderstate.JCGLBlendState> suggestedBlendState()

      Description copied from interface: `R2ShaderTranslucentUsableType`
      A specification of the blending state with which this shader is intended to be used. An empty value indicates that blending is intended to be disabled.
      Specified by:
        `suggestedBlendState` in interface `R2ShaderTranslucentUsableType<R2RefractionMaskedDeltaParameters>`
      Returns:
        The blending configuration with which this shader is intended to be used

Copyright © 2017 <code@io7m.com> http://io7m.com